libpqxx: pqxx::cursor_base Class Reference

libpqxx 4.0.1

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Types | Public Member Functions | Protected Member Functions | Protected Attributes | List of all members
pqxx::cursor_base Class Reference

Common definitions for cursor types. More...

`#include <cursor.hxx>`

Inheritance diagram for pqxx::cursor_base:

## Public Types
enum | accesspolicy { forward_only, random_access }
| Cursor access-pattern policy. More...
enum | updatepolicy { read_only, update }
| Cursor update policy. More...
enum | ownershippolicy { owned, loose }
| Cursor destruction policy. More...
typedef result::size_type | size_type
typedef result::difference_type | difference_type

## Public Member Functions
const std::string & | name () const throw ()
| Name of underlying SQL cursor.

## Static Public Member Functions
Special movement distances
static difference_type | all () throw ()
| Special value: read until end.
static difference_type | next () throw ()
| Special value: read one row only.
static difference_type | prior () throw ()
| Special value: read backwards, one row only.
static difference_type | backward_all () throw ()
| Special value: read backwards from current position back to origin.

## Protected Member Functions
| cursor_base (connection_base &, const std::string &Name, bool embellish_name=true)

## Protected Attributes
const std::string | m_name

## Detailed Description

Common definitions for cursor types.

In C++ terms, fetches are always done in pre-increment or pre-decrement fashion–i.e. the result does not include the row the cursor is on at the beginning of the fetch, and the cursor ends up being positioned on the last row in the result.

There are singular positions akin to `end()` at both the beginning and the end of the cursor's range of movement, although these fit in so naturally with the semantics that one rarely notices them. The cursor begins at the first of these, but any fetch in the forward direction will move the cursor off this position and onto the first row before returning anything.

## Member Typedef Documentation

typedef result::difference_type pqxx::cursor_base::difference_type

typedef result::size_type pqxx::cursor_base::size_type

## Member Enumeration Documentation

enum pqxx::cursor_base::accesspolicy

Cursor access-pattern policy.

Allowing a cursor to move forward only can result in better performance, so use this access policy whenever possible.

Enumerator:

  forward_only | Cursor can move forward only.
  random_access | Cursor can move back and forth.

enum pqxx::cursor_base::ownershippolicy

Cursor destruction policy.

The normal thing to do is to make a cursor object the owner of the SQL cursor it represents. There may be cases, however, where a cursor needs to persist beyond the end of the current transaction (and thus also beyond the lifetime of the cursor object that created it!), where it can be "adopted" into a new cursor object. See the basic_cursor documentation for an explanation of cursor adoption.

If a cursor is created with "loose" ownership policy, the object representing the underlying SQL cursor will not take the latter with it when its own lifetime ends, nor will its originating transaction.

Warning
  Use this feature with care and moderation. Only one cursor object should be responsible for any one underlying SQL cursor at any given time.
  Don't "leak" cursors! As long as any "loose" cursor exists, any attempts to deactivate or reactivate the connection, implicitly or explicitly, are quietly ignored.

Enumerator:

  owned | Destroy SQL cursor when cursor object is closed at end of transaction.
  loose | Leave SQL cursor in existence after close of object and transaction.

enum pqxx::cursor_base::updatepolicy

Cursor update policy.

Warning
  Not all PostgreSQL versions support updatable cursors.

Enumerator:

  read_only | Cursor can be used to read data but not to write.
  update | Cursor can be used to update data as well as read it.

## Constructor & Destructor Documentation

pqxx::cursor_base::cursor_base | ( | connection_base & | context,
|  | const std::string & | Name,
|  | bool | embellish_name = `true`
| ) |  |
| protected

References cursor_base().

Referenced by cursor_base().

## Member Function Documentation

cursor_base::difference_type pqxx::cursor_base::all | ( |  | ) | throw ()
| static

Special value: read until end.

Returns
  Maximum value for result::difference_type, so the cursor will attempt to read the largest possible result set.

Referenced by pqxx::internal::obtain_stateless_cursor_size().

cursor_base::difference_type pqxx::cursor_base::backward_all | ( |  | ) | throw ()
| static

Special value: read backwards from current position back to origin.

Returns
  Minimum value for result::difference_type

Referenced by pqxx::stateless_cursor< up, op >::stateless_cursor().

const std::string& pqxx::cursor_base::name | ( |  | ) | const throw ()

Name of underlying SQL cursor.

Returns
  Name of SQL cursor, which may differ from original given name.

Warning
  Don't use this to access the SQL cursor directly without going through the provided wrapper classes!

Referenced by pqxx::internal::sql_cursor::sql_cursor().

static difference_type pqxx::cursor_base::next | ( |  | ) | throw ()
| static

Special value: read one row only.

Returns
  Unsurprisingly, 1

static difference_type pqxx::cursor_base::prior | ( |  | ) | throw ()
| static

Special value: read backwards, one row only.

Returns
  Unsurprisingly, -1

## Member Data Documentation

const std::string pqxx::cursor_base::m_name
| protected

The documentation for this class was generated from the following files:

- cursor.hxx
- cursor.cxx